/*$Header: /afs/ece/usr/lowpower/CMUDSP/cvsroot/cmudsp/misc/c-code/qdvpp/qdvpp.c,v 1.1 1998/11/03 18:09:16 inacio Exp $*/
/*****************************************************************************
 *qdvpp.c
 *
 * Quick and dirty Verilog preprocessor
 *
 *
 *Chris Inacio
 *Carnegie Mellon University
 *Copyright (C) 1998
 *
 * $Author: inacio $
 * $Revision: 1.1 $
 * $Date: 1998/11/03 18:09:16 $
 *
 *****************************************************************************/
/*
 *$Log: qdvpp.c,v $
 *Revision 1.1  1998/11/03 18:09:16  inacio
 *This is the quick-n-dirty Verilog PreProcessor
 *
 * Revision 1.1  1998/07/29  03:01:48  inacio
 * Initial revision
 *
 *
 */
 

/*
 * includes
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "verilog.h"
#include "qdhash.h"


/*
 * prototypes
 */
void add_to_table (char *string);



/*****************************************************************************
 *main
 *
 *
 *****************************************************************************/
int 
main (int argc, char *argv[])
{

    FILE *infile;
    int loop;

   /*
    * initialize the hash table
    */
   hash_make_table();


   /*
    * initialize yyout to be stdout
    */
   yyout = stdout;

   /*
    * process command line defines
    */
   for (loop=1; loop<argc; loop++)
   {
      if (!strncmp ("-D",argv[loop],2))
      {
         add_to_table(argv[loop]);
      }
   }

   /*
    * process the files on the command line
    */
   for (loop=1; loop<argc; loop++)
   {
      if (strncmp ("-D",argv[loop],2))
      {
         infile = fopen (argv[loop], "r");
         if (infile)
         {
            yyin = infile;
            yylex ();
            fclose (infile);
         }
      }
   }

   return 0;
}



/*****************************************************************************
 *add_to_table
 *
 *
 *****************************************************************************/
void
add_to_table (char *string)
{
   int loop;
   char *name;
   Tdefined_val *new_def;
   
   
   for (loop=2; *(string+loop); loop++)
   {
      if (*(string+loop) == '=')
      {
         break;
      }
   }

   name = (char *) malloc ( (loop-1)*sizeof(char) );
   strncpy (name, (string+2), (loop+1));
   
   new_def = (Tdefined_val *) malloc (sizeof(Tdefined_val));
   new_def->name = name;
   new_def->str_value = NULL;
   new_def->num_value = 0;
   
   hash_add (new_def);      

}


/*****************************************************************************
 *****************************************************************************/
