module addr_bus_control (cpu_stop, mem_slct, C_PAB, C_XAB, C_YAB, rs_ab, 
						E_PAB, E_XAB, E_YAB);

//paramter abuswidth = 16;
`define abuswidth 16

input		cpu_stop;
input		[1:0]mem_slct;

input 	[(`abuswidth-1):0]C_PAB;
input		[(`abuswidth-1):0]C_XAB;
input		[(`abuswidth-1):0]C_YAB;
input		[(`abuswidth-1):0]rs_ab;


output	[(`abuswidth-1):0]E_PAB;
output	[(`abuswidth-1):0]E_XAB;
output	[(`abuswidth-1):0]E_YAB;

reg	[(`abuswidth-1):0]	E_PAB,E_XAB,E_YAB;



always @(cpu_stop or mem_slct or C_PAB or C_XAB or C_YAB or rs_ab)
begin

	if (cpu_stop == 1'b1)
		begin
			case (mem_slct)
				2'b00:
					begin
						E_PAB <= 256'bx;
						E_XAB <= rs_ab;
						E_YAB <= 256'bx;
					end
				2'b01:
					begin
						E_PAB <= 256'bx;
						E_XAB <= 256'bx;
						E_YAB <= rs_ab;
					end
				2'b10:
					begin
						E_PAB <= 256'bx;
						E_XAB <= 256'bx;
						E_YAB <= 256'bx;
					end
				2'b11:
					begin
						E_PAB <= rs_ab;
						E_XAB <= 256'bx;
						E_YAB <= 256'bx;
					end
			  endcase
		end
	else
		begin
			E_PAB <= C_PAB;
			E_XAB <= C_XAB;
			E_YAB <= C_YAB;
		end

end

endmodule


