/* $Id: ebus_drivers_control.v,v 1.3 1997/10/13 21:41:57 inacio Exp $ */
/*****************************************************************************
 *ebus_drivers_control.v
 *
 *control logic for the ebus drivers
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1997/10/13 21:41:57 $
 *Revision: $Revision: 1.3 $
 *
 *
 *Log: $Log: ebus_drivers_control.v,v $
 *Log: Revision 1.3  1997/10/13 21:41:57  inacio
 *Log: some modifications and bug fixes for Synopsys
 *Log:
# Revision 1.2  1997/10/13  20:38:56  inacio
# this is the control logic for the external bus drivers
#
# Revision 1.1  1997/10/10  20:30:55  inacio
# control logic for the ebus drivers, not done yet
#
 *****************************************************************************/


module ebus_drivers_control (cpu_stop, c_xab_ov, CX_WRITE, E_WRITE, EAB_DIR, 
									EAB_EN, EDB_BUSSEL, EDB_DIR, EDB_EN);


//parameter dbuswidth = 24;
//parameter abuswidth = 16;

input		cpu_stop;
input		c_xab_ov;
input		CX_WRITE;
input		E_WRITE;

output 	EAB_DIR;
output 	EAB_EN;
output 	EDB_BUSSEL;
output 	EDB_DIR;
output 	EDB_EN;


reg 		EAB_DIR;
reg 		EAB_EN;
reg 		EDB_BUSSEL;
reg 		EDB_DIR;
reg 		EDB_EN;



always @(cpu_stop or c_xab_ov or E_WRITE or CX_WRITE)
begin

	/*
	 *E address bus enable line
	 */
	if (cpu_stop == 1'b1 || c_xab_ov == 1'b1)
   	begin
   		EAB_EN <= 1'b0;
   	end
	else
		begin
			EAB_EN <= 1'b1;
		end
		
	/*
	 * E address bus direction line
	 */
	if (cpu_stop == 1'b1)
		begin
			EAB_DIR <= 1'b1;
		end
	else
		begin
			EAB_DIR <= 1'b0;
		end



	/*
	 *E data bus enable
	 */
	if (cpu_stop == 1'b1 || c_xab_ov == 1'b1)
		begin
			EDB_EN <= 1'b0;
		end
	else
		begin
			EDB_EN <= 1'b1;
		end


	/*
	 *E data bus direction
	 */
	if (cpu_stop == 1'b1)
		begin
			if (CX_WRITE == 1'b1)
				begin
					EDB_DIR <= 1'b1;
				end
			else
				begin
					EDB_DIR <= 1'b0;
				end
		end
	else
		begin
			if (E_WRITE == 1'b0)
				begin
					EDB_DIR <= 1'b0;
				end
			else
				begin
					EDB_DIR <= 1'b1;
				end
		end


	/*
	 * E data bus bus select
	 */
	if (cpu_stop == 1'b1)
		begin
			EDB_BUSSEL <= 1'b1;
		end
	else
		begin
			EDB_BUSSEL <= 1'b0;
		end
		
end


endmodule

