/*
 Written by Andrew Ryan
 Fast version of bounds checker
 That's about it...
 6/11/98
 */



module bound_chk (linear, lower, upper, within_boundaries);
   input  [15:0] linear;
   input [15:0]  lower;
   input [15:0]  upper;
   output 	 within_boundaries;

   parameter 	 DPATH = "bound_chk";
   
   wire [15:0] 	 linear_not, upper_not;
   wire [16:0] 	 add_lower_out, add_upper_out;


   assign upper_not = ~upper;





   assign linear_not = ~linear;



   

   DW01_add #(17) add_upper (.A({1'b0, linear}), .B({1'b1, upper_not}), 
			       .CI(1'b0), .SUM(add_upper_out), .CO());







    DW01_add #(17) adder_lower (.A({1'b0, lower}), .B({1'b1, linear_not}), 
				.CI(1'b0), .SUM(add_lower_out), .CO()); 







   assign within_boundaries = add_upper_out[16] & add_lower_out[16];



				
endmodule // bound_chk_new



