/* $Id: mux2_1.v,v 2.1 1998/02/10 04:38:30 inacio Exp $ */
/*****************************************************************************
 *
 * mux2_1
 *
 * Almost a standard mux, except that this one is glitch free.
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1998/02/10 04:38:30 $
 *Revision: $Revision: 2.1 $
 *
 *
 *Log: $Log: mux2_1.v,v $
 *Log: Revision 2.1  1998/02/10 04:38:30  inacio
 *Log: this is a structural glitch free 2-to-1 mux
 *Log:
 *****************************************************************************/



/*****************************************************************************
 *
 * select     |    output signal
 * -----------+------------------
 *   0        |          B
 *   1        |          A
 *
 *****************************************************************************/

module mux2_1 (in_a, in_b, out, select);




   input    in_a;
   input    in_b;
   output   out;
   input    select;

   wire     not_select;
   wire     out_a1;
   


   /*
    * stdand2 (in0, in1, y);
    * stdor3 (in0, in1, in3, y);
    */
    
   stdinv inv_select (select, not_select);
   stdand2 and1 (in_a, select, out_a1);
   stdand2 and2 (in_a, in_b, out_a2);
   stdand2 and3 (in_b, not_select, out_a3);
   stdor3 the_or (out_a1, out_a2, out_a3, out);


endmodule


/*****************************************************************************
 *****************************************************************************/
