/* $Id: pads.v,v 1.20 1998/09/01 16:06:54 inacio Exp $ */
/*****************************************************************************
 *
 *
 *
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1998/09/01 16:06:54 $
 *Revision: $Revision: 1.20 $
 *
 *
 *Log: $Log: pads.v,v $
 *Log: Revision 1.20  1998/09/01 16:06:54  inacio
 *Log: changed the comments to CMu DSP
 *Log:
# Revision 1.19  1998/08/26  19:48:53  inacio
# changed the module names to cmudsp
#
# Revision 1.18  1998/07/01  19:28:34  inacio
# *** empty log message ***
#
# Revision 1.17  1998/05/11  14:35:18  ar39
# *** empty log message ***
#
 *Log: Revision 1.16  1998/03/30 19:17:20  ar39
 *Log: *** empty log message ***
 *Log:
 *Log: Revision 1.15  1998/02/18 23:01:38  benk
 *Log: Fixed EAB, EDB pins
 *Log:
# Revision 1.14  1998/02/14  16:29:19  ar39
# Added a third clock net.
#
 *Log: Revision 1.13  1998/02/12 15:45:13  ar39
 *Log: I made Chris's epoch copier correct without symbolic links.
 *Log:
 *Log: Revision 1.12  1998/01/19 17:55:58  inacio
 *Log: got rid of clock attribute lines because cascade wasn't accepting them
 *Log:
# Revision 1.11  1998/01/16  21:15:16  inacio
# added comments for telling cascade about clocks
#
# Revision 1.10  1997/12/13  05:31:40  inacio
# added some parameters to the bidirectional pads to make sure they aren't
# getting pull-ups or pull-downs.  I don't think they are.
#
# Revision 1.9  1997/12/11  22:06:25  inacio
# changed the pads so 1 set powers the pins and the other set powers the rails
#
# Revision 1.8  1997/12/05  19:02:48  inacio
# added a lot more power and ground pad pairs
#
# Revision 1.7  1997/12/04  23:27:53  inacio
# corrected the parameter order for the e_write and e_outen pads
#
# Revision 1.6  1997/11/30  07:54:35  inacio
# changed e_write and e_outen from being inouts to input pads, as they should
# be from the change in the way the bus works
#
# Revision 1.5  1997/11/28  05:59:18  inacio
# updated the pad definitions for the new version of the ebus
#
# Revision 1.4  1997/11/07  22:47:49  inacio
# changed some names to match up from SCANOUT to SCAN_OUT
#
# Revision 1.3  1997/11/04  08:32:29  inacio
# split up the EDB, sized EAB correctly.  got rid of some wrong options I was
# trying to pass to Epoch, etc.
#
# Revision 1.2  1997/11/02  08:08:44  inacio
# moved the pins around, (makes sense for the package layout,) and I added
# power and ground pins
#
# Revision 1.1  1997/11/02  08:06:54  inacio
# Initial revision
#
# Revision 1.1  1997/10/29  22:46:57  inacio
# The file defines the pads for the CMUDSP, power and GND not included
#
 *****************************************************************************/


`define databus 23:0
`define addrbus 15:0

module pads   (CLOCK_pad, RESET_pad, MEM_SLCT_pad, ESTROBE_pad, EACCESS_pad,
					EENABLE_pad, EAB_pad, EDB_pad, E_OUTEN_pad, E_WRITE_pad,
					TEST_pad, SCAN_IN_pad, SCAN_OUT_pad, PWR0_rail, PWR1_rail,
					PWR2_rail, PWR3_rail, PWR4, PWR5, PWR6, PWR7, PWR8, PWR9,
					GND0_rail, GND1_rail, GND2_rail, GND3_rail, GND4, GND5, GND6,
					GND7, GND8, GND9);


// epoch set_attribute PACKAGE = "cda84p470"


/*
 * pin directions
 */
input		CLOCK_pad;
input		RESET_pad;
input		[1:0]MEM_SLCT_pad;
output		ESTROBE_pad;
output		EACCESS_pad;
input		EENABLE_pad;
inout		[`addrbus]EAB_pad;
inout		[23:0]EDB_pad;
input		E_OUTEN_pad;
input		E_WRITE_pad;
input		TEST_pad;
input		SCAN_IN_pad;
output		SCAN_OUT_pad;
output		PWR0_rail;
output		PWR1_rail;
output		PWR2_rail;
output		PWR3_rail;
output		PWR4;
output		PWR5;
output		PWR6;
output		PWR7;
output		PWR8;
output		PWR9;
output		GND0_rail;
output		GND1_rail;
output		GND2_rail;
output		GND3_rail;
output		GND4;
output		GND5;
output		GND6;
output		GND7;
output		GND8;
output		GND9;

/*
 *wires
 */
wire		CLOCK;
wire		RESET;
wire		[1:0]MEM_SLCT;
wire		ESTROBE;
wire		EACCESS;
wire		EENABLE;
wire		[`addrbus]EAB;
wire		[`databus]EDB;
wire		E_OUTEN;
wire		E_WRITE;
wire		TEST;
wire		SCAN_IN;
wire		SCAN_OUT;
wire		edb_dir;
wire		edb_en;
wire		eab_dir;
wire		eab_en;

//
// pads:
//   East (21 pins):
//	1	unused
//	2	unused
//	3	GND_rail
//	4	GND
//	5	CLOCK
//	6	RESET
//	7	ESTROBE
//	8	EACCESS
//	9	SCAN_OUT
//	10	unused
//	11	PWR 
//	12	EAB[0]
//	13	EAB[1]
//	14	EAB[2]
//	15	EAB[3]
//	16	EAB[4]
//	17	EAB[5]
//	18	EAB[6]
//	19	GND
//	20	GND_rail
//	21	unused 
//
//   North (21 pins):
//	22	unused
//	23	PWR_rail
//	24	PWR
//	25	EENABLE
//	26	TEST
//	27	E_WRITE
//	28	EAB[7]
//	29	EAB[8]
//	30	EAB[9]
//	31	EAB[10]
//	32	GND
//	33	EAB[11]
//	34	EAB[12]
//	35	EAB[13]
//	36	EAB[14]
//	37	EAB[15]
//	38	EDB[0]
//	39	EDB[1]
//	40	PWR
//	41	PWR_rail
//	42	unused
//
//   West (21 pins):
//	43	unused
//	44	GND_rail
//	45	GND
//	46	SCAN_IN
//	47	unused
//	48	EDB[2]
//	49	EDB[3]
//	50	EDB[4]
//	51	EDB[5]
//	52	PWR
//	53	EDB[6]
//	54	EDB[7]
//	55	EDB[8]
//	56	EDB[9]
//	57	EDB[10]
//	58	EDB[11]
//	59	EDB[12]
//	60	GND
//	61	GND_rail
//	62	unused
//	63	unused
//
//   South (21 pins):
//	64	unused
//	65	PWR_rail
//	66	PWR
//	67	MEM_SLCT[0]
//	68	MEM_SLCT[1]
//	69	E_OUTEN
//	70	EDB[13]
//	71	EDB[14]
//	72	EDB[15]
//	73	EDB[16]
//	74	GND
//	75	EDB[17]
//	76	EDB[18]
//	77	EDB[19]
//	78	EDB[20]
//	79	EDB[21]
//	80	EDB[22]
//	81	EDB[23]
//	82	PWR
//	83	PWR_rail
//	84	unused
//

/*
 *Input Pads (10)
 */
padin_buf #( 5,  5) PAD_clock (CLOCK_pad, CLOCK);
padin_buf #( 6,  6) PAD_reset (RESET_pad, RESET);
padin_buf #(25, 25) PAD_eenable (EENABLE_pad, EENABLE);
padin_buf #(26, 26) PAD_test (TEST_pad, TEST);
padin_buf #(46, 46) PAD_scanin (SCAN_IN_pad, SCAN_IN);
padin_buf #(67, 68) PAD_mem_slct (MEM_SLCT_pad, MEM_SLCT);
padin_buf #(69, 69) PAD_e_outen (E_OUTEN_pad, E_OUTEN);
padin_buf #(27, 27) PAD_e_write (E_WRITE_pad, E_WRITE);



/*
 *Output Pads (4)
 */
padout #( 7,  7) PAD_estrobe (ESTROBE, ESTROBE_pad);
padout #( 8,  8) PAD_eaccess (EACCESS, EACCESS_pad);
padout #( 9,  9) PAD_scanout (SCAN_OUT, SCAN_OUT_pad);

/*
 *Bidirectional Pads (40) -- yuck!
 */
padbi #(18, 12) PAD_eab1 (eab_en, eab_dir, EAB[ 6: 0], EAB_pad[ 6: 0]);
padbi #(31, 28) PAD_eab2 (eab_en, eab_dir, EAB[10: 7], EAB_pad[10: 7]);
padbi #(37, 33) PAD_eab3 (eab_en, eab_dir, EAB[15:11], EAB_pad[15:11]);

padbi #(39, 38) PAD_edb1 (edb_en, edb_dir, EDB[ 1: 0], EDB_pad[ 1: 0]);
padbi #(51, 48) PAD_edb2 (edb_en, edb_dir, EDB[ 5: 2], EDB_pad[ 5: 2]);
padbi #(59, 53) PAD_edb3 (edb_en, edb_dir, EDB[12: 6], EDB_pad[12: 6]);
padbi #(73, 70) PAD_edb4 (edb_en, edb_dir, EDB[16:13], EDB_pad[16:13]);
padbi #(81, 75) PAD_edb5 (edb_en, edb_dir, EDB[23:17], EDB_pad[23:17]);


/*
 *Power and Ground (20)
 */
padvdd #(23, 0, "RAIL_ONLY") PAD_pwr0 (PWR0_rail);
padvdd #(41, 0, "RAIL_ONLY") PAD_pwr1 (PWR1_rail);
padvdd #(65, 0, "RAIL_ONLY") PAD_pwr2 (PWR2_rail);
padvdd #(83, 0, "RAIL_ONLY") PAD_pwr3 (PWR3_rail);
padvdd #(11, 0, "CORE_ONLY") PAD_pwr4 (PWR4);
padvdd #(24, 0, "CORE_ONLY") PAD_pwr5 (PWR5);
padvdd #(40, 0, "CORE_ONLY") PAD_pwr6 (PWR6);
padvdd #(52, 0, "CORE_ONLY") PAD_pwr7 (PWR7);
padvdd #(66, 0, "CORE_ONLY") PAD_pwr8 (PWR8);
padvdd #(82, 0, "CORE_ONLY") PAD_pwr9 (PWR9);

padgnd #( 3, 0, "RAIL_ONLY") PAD_gnd0 (GND0_rail);
padgnd #(20, 0, "RAIL_ONLY") PAD_gnd1 (GND1_rail);
padgnd #(44, 0, "RAIL_ONLY") PAD_gnd2 (GND2_rail);
padgnd #(61, 0, "RAIL_ONLY") PAD_gnd3 (GND3_rail);
padgnd #( 4, 0, "CORE_ONLY") PAD_gnd4 (GND4);
padgnd #(19, 0, "CORE_ONLY") PAD_gnd5 (GND5);
padgnd #(32, 0, "CORE_ONLY") PAD_gnd6 (GND6);
padgnd #(45, 0, "CORE_ONLY") PAD_gnd7 (GND7);
padgnd #(60, 0, "CORE_ONLY") PAD_gnd8 (GND8);
padgnd #(74, 0, "CORE_ONLY") PAD_gnd9 (GND9);


/*
 *build the cpu inside
 */
cmudsp processor (CLOCK, RESET, MEM_SLCT, ESTROBE, EACCESS, EENABLE, EAB,
                  EDB, E_OUTEN, E_WRITE, TEST, SCAN_IN,
                  SCAN_OUT, edb_dir, edb_en, eab_dir, eab_en);



endmodule
