/*	File:	regset_selector_c.v				*/

/*	module name: regset_selector_c					*/


/* Author: Jonathan Tong */


/*==============================================================================*/


/********************************************************************************/
/*																				*/
/*	module:	regset_selector_c													*/
/*																				*/
/********************************************************************************/

module regset_selector_c (
	Mwrite2,
	Nwrite2,
	Rwrite2,
	regset_select
	);

/*==============================================================================*/
/*============	I/O direction	================================================*/
/*==============================================================================*/


input Mwrite2;
input Nwrite2;
input Rwrite2;

output [1:0] regset_select;

/*==============================================================================*/
/*===========	Internal Nets	================================================*/
/*==============================================================================*/

reg [1:0] regset_select;

/*==============================================================================*/
/*	Processes																	*/
/*==============================================================================*/

always @(Mwrite2 or Nwrite2 or Rwrite2 )
begin
	if (Rwrite2)
	    regset_select = 2'b00;
	else if (Mwrite2)
	    regset_select = 2'b01;
	else if (Nwrite2)
	    regset_select = 2'b10;
	else
	    regset_select = 2'b00;  

end /* always */


endmodule /* end module regset_selector_c */
