/* $Id: transceiver.v,v 1.2 1997/11/09 08:51:32 inacio Exp $ */
/*****************************************************************************
 *transceiver.v
 *
 *
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1997/11/09 08:51:32 $
 *Revision: $Revision: 1.2 $
 *
 *
 *Log: $Log: transceiver.v,v $
 *Log: Revision 1.2  1997/11/09 08:51:32  inacio
 *Log: I changed the tabbing in the files to be spaces, now it looks the same in
 *Log: less as it does in my editor
 *Log:
# Revision 1.1  1997/10/01  22:41:03  inacio
# transceiver module for the ramswitch
#
 *****************************************************************************/
             


/*****************************************************************************
 *module transceiver
 *
 *Input Pins - enable  - active high
 *     direction - 1 -> IN to Y
 *         - 0 -> Y to IN
 *     IN    - input/output vector
 *         - input/output vector
 *
 *Module Parameters - bit_width - number of tribufs and size of IN and Y
 *       - data_path - defaults to 1, which is datapath type
 *              gate
 *****************************************************************************/
module transceiver (enable, direction, IN, Y);

input enable;
input direction;
inout IN;
inout Y;

parameter bit_width = 1;
parameter data_path = 1;


stdinv dirinv (direction, dirbar);
stdnand2 nandy2in (direction, enable, en_y2in);
stdnand2 nandin2y (dirbar, enable, en_in2y);

tribuf #(bit_width, data_path) in_to_y (en_in2y, IN, Y);
tribuf #(bit_width, data_path) y_to_in (en_y2in, Y, IN);


endmodule



/*****************************************************************************
 *****************************************************************************/
